fedifinderdev/blog/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('about/', views.about, name='blog-about'),
    path('blog/', views.blog, name='blog-home'),
    path('', views.splash, name='splash'),
]

fedifinderdev/fedifinderdev/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include('blog.urls')),
    path('find/', include('match.urls')),
    path('admin/', admin.site.urls),
]

fedifinderdev/match/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('', views.home, name='match-home'),
    path('test/', views.test, name='match-test'),
    path('stats/', views.stats, name='match-stats'),
    path('avis/', views.get_images, name='match-avis'),
    path('gallery/', views.gallery, name='match-gallery'),
    path('browse/', views.browse, name='match-browse-base'),
    path('browse/<str:main>/', views.browse, name='match-browse-one'),
    path('browse/<str:main>/<str:sec>', views.browse, name='match-browse-two'),
    path('search/', views.search_in, name='match-search-in'),
    path('search/<str:src_str>', views.search_out, name='match-search-out'),
    path('quiz/', views.quiz_view, name='match-quiz'),
    path('quiz/<str:inst>/<str:uname>', views.quiz_view, name='match-quiz'),
    path('user/<str:inst>/<str:uname>', views.profile_view, name='match-profile'),
    path('me/', views.profile_view, name='match-profile-me'),
    path('edit/', views.edit_account, name='match-edit'),
    path('udim/', views.update_images, name='match-update-images'),
    path('request/', views.request_message, name='match-request-message'),
    path('delete/', views.delete, name='match-delete'),
    path('delete/<str:conf>', views.delete, name='match-delete-conf'),
    path('logout/', views.logout_user, name='match-logout'),
    path('login/', views.login_user, name='match-login'),
    path('login/redirect/<str:iname>', views.login_redirect, name='match-login-redirect'),
    path('login/redirect', views.login_redirect, name='match-login-redirect'),
]

fedifinderdev/match/models.py
from django.db import models
from django.contrib.auth.models import AbstractBaseUser, BaseUserManager
from django.utils.dateparse import parse_datetime


class fedi_manager(BaseUserManager):
    def create_user(self, email, username, password=None, **kwargs):
        print("Got to create_user")
        if not email:
            print("No email error")
            raise ValueError("Error creating user (FUN)")
        if not username:
            print("No username error")
            raise ValueError("Error creating user (JUN)")
        print("create_user data:")
        print("Email:" + email)
        print("Username:" + username)
        for entry in ['avatar', 'header', 'created_at', 'display_name', 'url', 'url_loc', 'note']:
            print(entry + ":" + str(kwargs.get(entry)))
        user = self.model(
            email=email,
            username=username,
            avatar=kwargs.get('avatar'),
            bio=kwargs.get('note'),
            header=kwargs.get('header'),
            join_fedi=kwargs.get('created_at'),
            uhand=kwargs.get('display_name'),
            uhost=kwargs.get('ref'),
            url_src=kwargs.get('url'),
            url_loc=kwargs.get('url_loc'),
            xyz="Y"
        )
        print("Create_user - self.model set")
        user.set_password(password)
        print("Create_user - password set")
        user.save(using=self.db)
        print("Create_user - user.save happened")
        return user

    def create_superuser(self, email, username, password, **kwargs):
        user = self.create_user(
            email=email,
            username=username,
            password=password,
            avatar='avatar',
            bio='note',
            header='header',
            created_at=parse_datetime("2021-06-01T00:00:00.000Z"),
            display_name='display_name',
            ref='ref',
            url_loc='url_l',
            url='url_s'
        )
        user.is_admin = True
        user.is_staff = True
        user.is_superuser = True
        user.save(using=self.db)
        return user


class fedi_user(AbstractBaseUser):

    class Genders(models.IntegerChoices):
        NOTH = 0
        MALE = 1
        FEMA = 2
        TRNM = 3
        TRNF = 4
        ENBY = 5

    class ISO(models.IntegerChoices):
        BTH = 0
        SOC = 1
        ROM = 2

    class Orient(models.IntegerChoices):
        NTH = 0
        HET = 1
        HOM = 2
        OTH = 3

    class RelStat(models.IntegerChoices):
        NTH = 0
        SNG = 1
        INR = 2
        MAR = 3
        DIV = 4
        WTM = 5

    objects = fedi_manager()
    age = models.IntegerField(default=0)                                 # Age (yr)
    attract = models.CharField(max_length=50, blank=True, null=True)      # Attracted to ______
    avatar = models.CharField(max_length=300)                             # Link to avatar image *
    bio = models.CharField(max_length=2000, blank=True, null=True)        # Bio text *
    email = models.EmailField(max_length=150, unique=True)                # Full handle (ABC@MNO.XYZ) *
    header = models.CharField(max_length=300)                             # Link to header image *
    height_ft = models.IntegerField(default=0)                            # Height (ft)
    height_in = models.IntegerField(default=0)                            # Height (in)
    interests = models.CharField(max_length=100, blank=True, null=True)   # Interest list string
    is_active = models.BooleanField(default=True)                         # Active status (REQ)
    is_admin = models.BooleanField(default=False)                         # Admin status (REQ)
    is_staff = models.BooleanField(default=False)                         # Staff status (REQ)
    is_superuser = models.BooleanField(default=False)                     # Superuser status (REQ)
    join_fedi = models.DateTimeField()                                    # Time user made account *
    join_match = models.DateTimeField(auto_now_add=True)                  # Time user made profile
    last_login = models.DateTimeField(auto_now=True)                      # Time user was last active
    lang_known = models.CharField(max_length=100, blank=True, null=True)  # Languages user knows
    lang_learn = models.CharField(max_length=100, blank=True, null=True)  # Languages user is learning
    location = models.CharField(max_length=50, blank=True, null=True)     # Location
    loc_lat = models.DecimalField(decimal_places=12, max_digits=14, default=0.000000000000)  # Location CoOrd. (Latitude)
    loc_lon = models.DecimalField(decimal_places=12, max_digits=15, default=0.000000000000)  # Location CoOrd. (Longitude)
    mbti = models.CharField(max_length=4, blank=True, null=True)         # Myers–Briggs Type Indicator
    occupation = models.CharField(max_length=50, blank=True, null=True)  # Occupation
    orient = models.IntegerField(choices=Orient.choices, default=0)      # Sexual orientation
    photos = models.CharField(max_length=2000, blank=True, null=True)    # Photo set list
    pol_soc = models.DecimalField(decimal_places=2, max_digits=4, default=0)  # Politics axis (social)
    pol_eco = models.DecimalField(decimal_places=2, max_digits=4, default=0)  # Politics axis (economic)
    quiz = models.CharField(max_length=2000, blank=True, null=True)      # Questionnaire
    race = models.CharField(max_length=50, blank=True, null=True)        # Race
    reli = models.CharField(max_length=50, blank=True, null=True)        # Religion
    rel_stat = models.IntegerField(choices=RelStat.choices, default=0)   # Relationship status
    report = models.CharField(max_length=100, blank=True, null=True)     # Report status
    seek = models.IntegerField(choices=ISO.choices, default=0)           # User is seeking
    sex = models.IntegerField(choices=Genders.choices, default=0)        # Gender
    uhand = models.CharField(max_length=75)                              # Display name *
    uhost = models.CharField(max_length=75)                              # Instance name (abc@MNO.XYZ)*
    username = models.CharField(max_length=75)                           # Username (ABC@mno.xyz) *
    url_loc = models.CharField(max_length=100, unique=True)              # Link to user profile on site
    url_src = models.CharField(max_length=150, unique=True)              # Link to user profile on instance *
    weight = models.IntegerField(default=0)                              # Weight (lb)
    xyz = models.CharField(max_length=150, blank=True, null=True)        # Misc info

    USERNAME_FIELD = 'email'
    REQUIRED_FIELDS = ['username']

    def __str__(self):
        return self.email

    def has_perm(self, perm, obj=None):
        return self.is_admin

    def has_module_perms(self, app_label):
        return True

fedifinderdev/match/forms.py
from django import forms
from django.utils.http import urlencode
from urllib.parse import quote, unquote
from .models import fedi_user
from .keydict import chk_str, inst_alias_rev


class InstanceForm(forms.Form):
    instance_url = forms.CharField(label='Instance URL', max_length=75)


class RequestForm(forms.Form):
    request_msg = forms.CharField(label='Request Message', max_length=75)


class SearchForm(forms.Form):

    seek = forms.IntegerField(required=False)
    sex = forms.IntegerField(required=False)
    rel_stat = forms.IntegerField(required=False)
    orient = forms.IntegerField(required=False)
    quad = forms.IntegerField(required=False)
    uhand = forms.CharField(max_length=75, required=False)
    username = forms.CharField(max_length=75, required=False)
    uhost = forms.CharField(max_length=75, required=False)
    attract = forms.CharField(max_length=50, required=False)
    race = forms.CharField(max_length=50, required=False)
    reli = forms.CharField(max_length=50, required=False)
    mbti = forms.CharField(max_length=4, required=False)
    bio = forms.CharField(max_length=100, required=False)
    interests = forms.CharField(max_length=100, required=False)
    quiz = forms.CharField(max_length=100, required=False)
    lang_known = forms.CharField(max_length=50, required=False)
    lang_learn = forms.CharField(max_length=50, required=False)
    location = forms.CharField(max_length=50, required=False)
    loc_dis = forms.IntegerField(required=False)
    loc_uni = forms.IntegerField(required=False)
    loc_lat = forms.DecimalField(decimal_places=12, max_digits=14, required=False)
    loc_lon = forms.DecimalField(decimal_places=12, max_digits=15, required=False)
    occupation = forms.CharField(max_length=50, required=False)
    join_fedi_min = forms.CharField(max_length=10, required=False)
    join_fedi_max = forms.CharField(max_length=10, required=False)
    join_match_min = forms.CharField(max_length=10, required=False)
    join_match_max = forms.CharField(max_length=10, required=False)
    height_ft_min = forms.IntegerField(required=False)
    height_in_min = forms.IntegerField(required=False)
    height_ft_max = forms.IntegerField(required=False)
    height_in_max = forms.IntegerField(required=False)
    weight_min = forms.IntegerField(required=False)
    weight_max = forms.IntegerField(required=False)
    age_min = forms.IntegerField(required=False)
    age_max = forms.IntegerField(required=False)

    def search(self):
        print("Got to search")
        search_string = "SS%26%26"
        search_params = {}
        for key in self.cleaned_data:
            if self.cleaned_data[key] != "" and self.cleaned_data[key] != None:  # Shorthand skips integers with value 0
                search_params[key] = self.cleaned_data[key]
        search_string += quote(urlencode(search_params))
        search_string += "%26%26" + chk_str(unquote(search_string))
        return search_string


class ProfileUpdateForm(forms.ModelForm):

    class Meta:
        model = fedi_user
        fields = ('age', 'attract', 'bio', 'height_ft', 'height_in', 'interests', 'lang_known', 'lang_learn',
                  'location', 'loc_lat', 'loc_lon', 'mbti', 'occupation', 'orient', 'photos',
                  'pol_eco', 'pol_soc', 'quiz', 'race', 'reli', 'rel_stat', 'seek', 'sex', 'uhand', 'weight')

    def clean_photos(self):
        data = self.cleaned_data.get('photos')
        # print("Raw: " + str(data))
        cleanbool = False
        cdnlist = ['static.banky.club', 'img.poast.org', 'l.poastcdn.org']  # Alternative list for CDN with different URL from instance
        cleanlist = cdnlist + list(inst_alias_rev.keys())  # CDN list first so break happens before instance detected
        if data and data != "None":  # Blank text box forms were sometimes populated with "None" as text
            linelist = data.split(sep="\r\n")
            print(linelist)
            for line in linelist:
                if line.startswith("[img]"):
                    link = line[5:]
                elif line.startswith("[post]"):
                    link = line[6:]
                else:
                    print("Your lines must be prepended with [img] or [post].")
                    raise forms.ValidationError("Your lines must be prepended with [img] or [post].")
                for key in cleanlist:
                    if key in link:  # Check that link has on 2 slashes before instance name (Not scam.xyz/instance.com)
                        test = link.split(key)  # And that preceding char precludes tweaked domains (123instance.com)
                        if test[0].count('/') == 2 and test[0][-1] in ['/', '.']:
                            cleanbool = True
                            break  # Should trigger before hitting the SPC part of https://static.banky.club/shitposter.club/yadayada
                    else:
                        cleanbool = False
                if not cleanbool:
                    print("Your photos/posts cannot come from unapproved instances. Sorry.")
                    raise forms.ValidationError("Your photos/posts cannot come from unapproved instances. Sorry.")
            return data
        else:
            return data

    def save(self, commit=True):
        fedi_user = super(ProfileUpdateForm, self).save(commit=False)
        for key in self.cleaned_data:  # cycle through all fields in form
            fedi_user.key = self.cleaned_data[key]  # update the user object values
        if fedi_user.xyz == "Y":
            fedi_user.xyz = "Z"
        if commit:
            fedi_user.save()
        return fedi_user

fedifinderdev/match/templates/match/base.html
<!doctype html>
<html lang="en">
{% load static %}
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link rel="shortcut icon" type="image/png" href="{%  static 'FF.fav-64.png' %}">
    <link rel="stylesheet" type="text/css" href="{% static 'css/main.css' %}">
    {% if title %}
        <title>{{title}} - FediFinder</title>
    {% else %}
        <title>FediFinder</title>
    {% endif %}

<body class = "body">
    <header class="topnav">
        {% if title == "Home"%}
            <a class="active" href="/">
                <img class="logo" src="{% static 'FF.logo.small.png' %}" alt="Logo-Home">
            </a>
        {% else %}
            <a href="/">
                <img class="logo" src="{% static 'FF.logo.small.png' %}" alt="Logo-Home">
            </a>
        {% endif %}
        {% if title == "About"%}
            <a class="active tnpad" href="/about">About</a>
        {% else %}
            <a class="tnpad" href="/about">About</a>
        {% endif %}
        {% if title == "Blog"%}
            <a class="active tnpad" href="/blog">Blog</a>
        {% else %}
            <a class="tnpad" href="/blog">Blog</a>
        {% endif %}
        {% if title == "Browse"%}
            <a class="active tnpad" href="/find/browse">Browse</a>
        {% else %}
            <a class="tnpad" href="/find/browse">Browse</a>
        {% endif %}
        {% if title == "Search"%}
            <a class="active tnpad" href="/find/search">Search</a>
        {% else %}
            <a class="tnpad" href="/find/search">Search</a>
        {% endif %}
        {% if title == "Me"%}
            <a class="active tnpad" href="/find/me">Me</a>
        {% else %}
            <a class="tnpad" href="/find/me">Me</a>
        {% endif %}
        {% if title == "Edit"%}
            <a class="active tnpad" href="/find/edit">Edit</a>
        {% else %}
            <a class="tnpad" href="/find/edit">Edit</a>
        {% endif %}
        {% if request.user.is_authenticated %}
            <a class="tnpad" href="/find/logout">Logout</a>
        {% else %}
            <a class="tnpad" href="/find/login">Login</a>
        {% endif %}
    </header>

    <main role="main" class="content-section">
          {% block content %}{% endblock %}
    </main>
</body>
</html>

fedifinderdev/match/templates/match/delete.html
{% extends "blog/base.html" %}
{% block content %}
{% csrf_token %}

<style type="text/css">
	.red{color: #F70D1A}
</style>
    <p>This is just a confirmation page to ensure you meant to delete your profile and didn't click that link by mistake.</p>
    <p>To continue and actually delete your account, just click the link below, this is the only barrier.</p>
    <p>You can create a profile with your account again at any time.</p>
    <p><a class="red" href="/find/delete/forreal-{{msg}}">Click here to really delete your account</a></p>

{% endblock content %}

fedifinderdev/match/templates/match/gallery.html
{% extends 'match/base.html' %}
{% load static %}
{% block content %}
{% csrf_token %}

<style type="text/css">
	.photo-grid{
		display: grid;
		gap: 1rem;

		grid-template-columns: repeat(auto-fit, minmax(120px, 1fr));
  		grid-auto-rows: 120px;
	}
	.card {
		display: flex;
		flex-direction: column;
		justify-content: center;
		align-items: center;
		text-align: center;
		background: #353535;
		font-size: 3rem;
		color: #fff;
		box-shadow: rgba(3, 8, 20, 0.1) 0px 0.15rem 0.5rem, rgba(2, 8, 20, 0.1) 0px 0.075rem 0.175rem;
		height: 100%;
		width: 100%;
		border-radius: 4px;
		transition: all 500ms;
		overflow: hidden;
		background-size: cover;
		background-position: center;
		background-repeat: no-repeat;
	 }
	.card:hover {
		box-shadow: rgba(2, 8, 20, 0.1) 0px 0.35em 1.175em, rgba(2, 8, 20, 0.08) 0px 0.175em 0.5em;
		transform: translateY(-3px) scale(1.1);
	}
</style>


<div class="photo-grid">
	{% for photo in photos %}
		<a href="{{photo.2}}" title="{{photo.0}}" target="_blank">
			<div class="card" style="background-image:url({{photo.1}})"></div>
		</a>
	{% endfor %}
</div>

{% endblock content %}

fedifinderdev/match/templates/match/generic_error.html
{% extends 'match/base.html' %}
{% load static %}
{% block content %}
{% csrf_token %}
<style type="text/css">
	.red{color: #F70D1A}
</style>

{% if Error %}
    <h4 class="red">Error</h4>
    {{Error}}
{% endif %}

{% endblock content %}

fedifinderdev/match/templates/match/quiz.html
{% extends 'match/base.html' %}
{% load static %}
{% block content %}

<form class="form-signin" method="post" enctype="multipart/form-data">
    {% csrf_token %}
    <h1>Questionnaire for {{for}}</h1>
    <p>Your response will be sent via fedi DM from the <a href="https://noagendasocial.com/web/@FediFinder">QuizBot</a>, please use this responsibly.</p>
    <p>Responses will only be sent if the bot's instance is online and depending on load the request may take some time. The page may hang for up to 60s after you hit submit, do not worry.
       You will be redirected to either an error or success page and if it succeeds you will be tagged in the post.</p>
    <p>You are limited to {{ans_len}} characters per answer; if you try to input more, your text will be cut off.</p>
    {% for question in quiz %}
		<h4>{{question}}</h4>
		<textarea name="q{{forloop.counter}}" id="id_input_q{{forloop.counter}}" cols="100" rows="{{ans_row}}" maxlength="{{ans_len}}"></textarea>
	{% endfor %}
    <br>
    <input type="submit" value="Submit">
</form>

{% endblock content %}

fedifinderdev/match/templates/match/request_form.html
{% extends 'match/base.html' %}
{% load static %}
{% block content %}
<form action="/find/request/" method="post">
    {% csrf_token %}
    <h4>Instance Inclusion Request Form</h4>
    Construct the message however you like but please include the following:<br>
    - The name of the instance to be included<br>
    - Your handle on fedi e.g. "@someone@instance.tld"<br>
    - If your instance already has a common abbreviation e.g. SPC or FSE<br><br>
    The page may take some time to load (30s-1m) so please be patient and only hit 'Submit' once.<br>
    <label for="id_request_msg">Request Message:</label><br>
    <textarea name="request_msg" id="id_request_msg" cols="100" rows="20" maxlength="2000"></textarea>
    <input type="submit" value="Submit">
</form>
{% endblock content %}

fedifinderdev/match/templates/match/search_input.html
{% extends 'match/base.html' %}
{% load static %}
{% block content %}

<form class="form-signin" method="post" enctype="multipart/form-data">{% csrf_token %}

	<h4>Seeking</h4>
	<select name="seek" id="id_seek">
		<option value="0">Both</option>
		<option value="1">Social</option>
		<option value="2">Romantic</option>
		<option value="3">Any</option>
	</select>
	<script>document.getElementById('id_seek').value=3;</script>

	<h4>Sex</h4>
	<select name="sex" id="id_sex">
		<option value="0">Not telling</option>
		<option value="1">Male</option>
		<option value="2">Female</option>
		<option value="3">Trans(M)</option>
		<option value="4">Trans(F)</option>
		<option value="5">Non-Binary</option>
		<option value="6">Any</option>
	</select>
	<script>document.getElementById('id_sex').value=6;</script>

	<h4>Relationship status</h4>
	<select name="rel_stat" id="id_rel_stat">
		<option value="0">Not telling</option>
		<option value="1">Single</option>
		<option value="2">In a relationship</option>
		<option value="3">Married</option>
		<option value="4">Divorced</option>
		<option value="5">Waiting for a miracle</option>
		<option value="6">Any</option>
	</select>
	<script>document.getElementById('id_rel_stat').value=6;</script>

	<h4>Orientation</h4>
	<select name="orient" id="id_orient">
		<option value="0">Not telling</option>
		<option value="1">Hetero</option>
		<option value="2">Homo</option>
		<option value="3">Other</option>
		<option value="4">Any</option>
	</select>
	<script>document.getElementById('id_orient').value=4;</script>

	<h4>Political Quadrant</h4>
	<select name="quad" id="id_quad">
		<option value="0">Any</option>
		<option value="1">Authoritarian Left</option>
		<option value="2">Authoritarian Right</option>
		<option value="3">Libertarian Left</option>
		<option value="4">Libertarian Right</option>
	</select>

	<h4>Display Name</h4>
	<input type="text" name="uhand" id="id_input_uhand" maxlength="75" class="form-control" placeholder="Display Name" autofocus>

	<h4>Username</h4>
	<input type="text" name="username" id="id_input_username" maxlength="75" class="form-control" placeholder="Username">

	<h4>User Instance</h4>
	<input type="text" name="uhost" id="id_input_uhost" maxlength="75" class="form-control" placeholder="Instance name">

	<h4>Attraction</h4>
	<input type="text" name="attract" id="id_input_attract" maxlength="50" class="form-control" placeholder="Attraction">

	<h4>Race/Ethnicity</h4>
	<input type="text" name="race" id="id_input_race" maxlength="50" class="form-control" placeholder="Race/Ethnicity">

	<h4>Language (Known)</h4>
	<input type="text" name="lang_known" id="id_input_lang_known" maxlength="50" class="form-control" placeholder="Language (Known)">

	<h4>Language (Learning)</h4>
	<input type="text" name="lang_learn" id="id_input_lang_learn" maxlength="50" class="form-control" placeholder="Language (Learning)">

	<h4>Religion</h4>
	<input type="text" name="reli" id="id_input_reli" maxlength="50" class="form-control" placeholder="Religion">

	<h4>Myers–Briggs Type</h4>
	<input type="text" name="mbti" id="id_input_mbti" maxlength="4" class="form-control" placeholder="OOOO">

	<h4>Bio</h4>
	<input type="text" name="bio" id="id_input_bio" maxlength="100" class="form-control" placeholder="Bio keyword(s)">

	<h4>Interests</h4>
	<input type="text" name="interests" id="id_input_interests" maxlength="100" class="form-control" placeholder="Interest keyword(s)">

	<h4>Questionnaire</h4>
	<input type="text" name="quiz" id="id_input_quiz" maxlength="100" class="form-control" placeholder="Questionnaire keyword(s)">

	<h4>Location (By name)</h4>
	<input type="text" name="location" id="id_input_location" maxlength="50" class="form-control" placeholder="Location name">

	<h4>Location (By distance)</h4>
	Within <input type="number" name="loc_dis" id="id_input_loc_dis" class="form-control" min=0 max=20000 step="1" placeholder="0">
	<select name="loc_uni" id="id_loc_uni">
		<option value="0">Mi</option>
		<option value="1">Km</option>
	</select> of these coordinates (Max 12 decimal places):
	<p>
	<label for="id_input_loc_lat">Latitude (-90,90): </label>
	<input type="number" name="loc_lat" id="id_input_loc_lat" class="form-control" min=-90 max=90 step="0.000000000001" placeholder="{{request.user.loc_lat}}">
	<br>
	<label for="id_input_loc_lon">Longitude (-180,180):</label>
	<input type="number" name="loc_lon" id="id_input_loc_lon" class="form-control" min=-180 max=180 step="0.000000000001" placeholder="{{request.user.loc_lon}}">
	</p>

	<h4>Occupation</h4>
	<input type="text" name="occupation" id="id_input_occupation" maxlength="50" class="form-control" placeholder="Occupation name">

	<h4>Joined the Fediverse</h4>
	<p>
		<label for="id_input_join_fedi_min">Between:</label>
		<input type="text" name="join_fedi_min" id="id_input_join_fedi_min" maxlength="10" class="form-control" placeholder="2021-06-01">
		<br>
		<label for="id_input_join_fedi_max">and:</label>
		<input type="text" name="join_fedi_max" id="id_input_join_fedi_max" maxlength="10" class="form-control" placeholder="2021-06-30">
	</p>
	<h4>Joined FediFinder</h4>
	<p>
		<label for="id_input_join_match_min">Between:</label>
		<input type="text" name="join_match_min" id="id_input_join_match_min" maxlength="10" class="form-control" placeholder="2021-06-01">
		<br>
		<label for="id_input_join_match_max">and:</label>
		<input type="text" name="join_match_max" id="id_input_join_match_max" maxlength="10" class="form-control" placeholder="2021-06-30">
	</p>

	<h4>Stats</h4>
	<p>
		<label for="id_input_height_ft_min">Height (Min.) (ft) (0-8):</label>
		<input type="number" name="height_ft_min" id="id_input_height_ft_min" class="form-control" min=0 max=8 placeholder=0>
		<br>
		<label for="id_input_height_ft_max">Height (Max.) (ft) (0-8):</label>
		<input type="number" name="height_ft_max" id="id_input_height_ft_max" class="form-control" min=0 max=8 placeholder=0>
	</p>
	<p>
		<label for="id_input_height_in_min">Height (Min.) (in) (0-11):</label>
		<input type="number" name="height_in_min" id="id_input_height_in_min" class="form-control" min=0 max=11 placeholder=0>
		<br>
		<label for="id_input_height_in_max">Height (Max.) (in) (0-11):</label>
		<input type="number" name="height_in_max" id="id_input_height_in_max" class="form-control" min=0 max=11 placeholder=0>
	</p>
	<p>
		<label for="id_input_weight_min">Weight (Min.) (lbs) (0-500):</label>
		<input type="number" name="weight_min" id="id_input_weight_min" class="form-control" min=0 max=500 placeholder=0>
		<br>
		<label for="id_input_weight_max">Weight (Max.) (lbs) (0-500):</label>
		<input type="number" name="weight_max" id="id_input_weight_max" class="form-control" min=0 max=500 placeholder=0>
	</p>
	<p>
	<label for="id_input_age_min">Age (Min.) (years) (18-100):</label>
	<input type="number" name="age_min" id="id_input_age_min" class="form-control" min=18 max=100 placeholder=0>
	<br>
	<label for="id_input_age_max">Age (Max.) (years) (18-100):</label>
	<input type="number" name="age_max" id="id_input_age_max" class="form-control" min=18 max=100 placeholder=0>
	</p>

	{% for field in form %}
	<p>
		{% for error in field.errors %}
	<p style="color: red">{{ error }}</p>
		{% endfor %}
	</p>
	{% endfor %}

	{% if form.non_field_errors %}
	<div style="color: red">
		<p>{{form.non_field_errors}}</p>
	</div>
	{% endif %}

	<button type="submit">Search</button>
</form>
{% endblock content %}

fedifinderdev/match/templates/match/search_output.html
{% extends 'match/base.html' %}
{% load static %}
{% block content %}
	{% include 'match/list_accounts.html' %}
{% endblock content %}